Scala Compiler2.13.0 < Back


# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  class Global extends SymbolTable with Closeable with CompilationUnits with Plugins with PhaseAssembly with Trees with Printers with DocComments with Positions with Reporting with Parsing
  Definition Classes
    nsc
- AbstractTypeRef
- AbstractTypeSymbol
- AliasTypeRef
- AliasTypeSymbol
- Alternative
- Alternative
- AlternativeApi
- AlternativeExtractor
- Annotatable
- Annotated
- Annotated
- AnnotatedApi
- AnnotatedExtractor
- AnnotatedType
- AnnotatedType
- AnnotatedTypeApi
- AnnotatedTypeExtractor
- AnnotationApi
- AnnotationChecker
- AnnotationExtractor
- AnnotationFilter
- AnnotationInfo
- AnnotationInfo
- AntiPolyType
- AppliedTypeTree
- AppliedTypeTree
- AppliedTypeTreeApi
- AppliedTypeTreeExtractor
- AppliedTypeVar
- Apply
- Apply
- ApplyApi
- ApplyDynamic
- ApplyExtractor
- ApplyImplicitView
- ApplyToImplicitArgs
- ApproximateDependentMap
- ArgsTypeRef
- ArrayAnnotArg
- ArrayValue
- AsSeenFromMap
- Assign
- Assign
- AssignApi
- AssignExtractor
- Attachable
- BackquotedIdentifierAttachment
- BaseTypeSeq
- Bind
- Bind
- BindApi
- BindExtractor
- Block
- Block
- BlockApi
- BlockExtractor
- BooleanFlag
- BooleanFlag
- BoundedWildcardType
- BoundedWildcardType
- BoundedWildcardTypeApi
- BoundedWildcardTypeExtractor
- CannotHaveAttrs
- CaseDef
- CaseDef
- CaseDefApi
- CaseDefExtractor
- ChangeOwnerTraverser
- ChildSolidDescendantsCollector
- ClassDef
- ClassDef
- ClassDefApi
- ClassDefExtractor
- ClassInfoType
- ClassInfoType
- ClassInfoTypeApi
- ClassInfoTypeExtractor
- ClassMirror
- ClassSymbol
- ClassSymbolApi
- ClassUnwrapper
- ClassfileAnnotArg
- CodePrinter
- CollectTreeTraverser
- CollectTypeCollector
- CommonNames
- CommonOwnerMap
- CompactTreePrinter
- CompatApi
- CompatToken
- CompilationUnit
- CompilationUnitContextApi
- CompleteAnnotationInfo
- CompoundType
- CompoundType
- CompoundTypeApi
- CompoundTypeTree
- CompoundTypeTree
- CompoundTypeTreeApi
- CompoundTypeTreeExtractor
- CompoundTypeTreeOriginalAttachment
- ConsoleWriter
- Constant
- Constant
- ConstantApi
- ConstantExtractor
- ConstantType
- ConstantType
- ConstantTypeApi
- ConstantTypeExtractor
- ConstructorNeedsFence
- ContainsAnyCollector
- ContainsAnyKeyCollector
- ContainsCollector
- CyclicReference
- DefDef
- DefDef
- DefDefApi
- DefDefExtractor
- DefTree
- DefTreeApi
- DefaultPosAssigner
- DefinitionsApi
- DefinitionsClass
- DelambdafyTarget
- DocComment
- DocDef
- EmptyScope
- EmptyTree
- ErasedValueType
- ErasedValueType
- ErroneousAnnotation
- ErrorScope
- ErrorType
- ExistentialExtrapolation
- ExistentialType
- ExistentialType
- ExistentialTypeApi
- ExistentialTypeExtractor
- ExistentialTypeTree
- ExistentialTypeTree
- ExistentialTypeTreeApi
- ExistentialTypeTreeExtractor
- ExistsTypeRefCollector
- ExpansionLimitExceeded
- Expr
- Expr
- FieldMirror
- FilterTreeTraverser
- FilterTypeCollector
- FindTreeTraverser
- FindTypeCollector
- FixedMirrorTreeCreator
- FixedMirrorTypeCreator
- Flag
- FlagAgnosticCompleter
- FlagAssigningCompleter
- FlagOps
- FlagValues
- FoldableConstantType
- FoldableConstantType
- ForEachTypeTraverser
- ForeachPartialTreeTraverser
- ForeachTreeTraverser
- FreeSymbol
- FreeTermSymbol
- FreeTermSymbolApi
- FreeTypeSymbol
- FreeTypeSymbolApi
- FreshNameExtractor
- Function
- Function
- FunctionApi
- FunctionExtractor
- GenPolyType
- GenericApply
- GenericApplyApi
- GlobalMirror
- GlobalPhase
- GlobalPlatform
- GlobalStats
- HKTypeVar
- Ident
- Ident
- IdentApi
- IdentExtractor
- If
- If
- IfApi
- IfExtractor
- ImplDef
- ImplDefApi
- Import
- Import
- ImportApi
- ImportExtractor
- ImportSelector
- ImportSelector
- ImportSelectorApi
- ImportSelectorExtractor
- ImportType
- ImportableAttachment
- Importer
- InfoTransformer
- InjectDerivedValue
- InlineAnnotatedAttachment
- InlineCallsiteAttachment
- InstanceMirror
- InstantiateDependentMap
- InternalApi
- InternalTransformer
- InternalTraverser
- InternalTreeCopierOps
- JavaArgumentApi
- JavaKeywords
- KeepOnlyTypeConstraints
- Keywords
- Kind
- Kind
- KindErrors
- LabelDef
- LabelDef
- LabelDefApi
- LabelDefExtractor
- LazyAnnotationInfo
- LazyPolyType
- LazyTreeCopier
- LazyType
- Liftable
- Liftable
- Literal
- Literal
- LiteralAnnotArg
- LiteralApi
- LiteralExtractor
- LiteralType
- LiteralType
- LocalOwnersTraverser
- Locator
- LookupAmbiguous
- LookupInaccessible
- LookupNotFound
- LookupSucceeded
- MacroCompatApi
- MacroInternalApi
- MalformedType
- MappedBaseTypeSeq
- Match
- Match
- MatchApi
- MatchExtractor
- MemberDef
- MemberDefApi
- MemberScopeApi
- MethodMirror
- MethodSymbol
- MethodSymbolApi
- MethodType
- MethodType
- MethodTypeApi
- MethodTypeExtractor
- MethodValue
- Mirror
- MissingAliasControl
- MissingTypeControl
- Modifiers
- Modifiers
- ModifiersApi
- ModifiersExtractor
- ModuleClassSymbol
- ModuleDef
- ModuleDef
- ModuleDefApi
- ModuleDefExtractor
- ModuleMirror
- ModuleSymbol
- ModuleSymbolApi
- ModuleTypeRef
- Name
- NameApi
- NameLookup
- NameOps
- NameTree
- NameTreeApi
- NamedArg
- NamedArg
- NamedArgApi
- NamedArgExtractor
- NamedType
- NamesApi
- NestedAnnotArg
- New
- New
- NewApi
- NewExtractor
- NoArgsTypeRef
- NoCommonType
- NoCompilationUnit
- NoInlineCallsiteAttachment
- NoPrefix
- NoSymbol
- NoType
- NoWarnAttachment
- NonClassTypeRef
- NullaryMethodType
- NullaryMethodType
- NullaryMethodTypeApi
- NullaryMethodTypeExtractor
- OuterArgCanBeElided
- OverloadedArgProto
- OverloadedType
- PackageClassInfoType
- PackageClassSymbol
- PackageDef
- PackageDef
- PackageDefApi
- PackageDefExtractor
- PackageObjectClassSymbol
- PackageTypeRef
- Parens
- PatVarDefAttachment
- PerRunParsing
- PerRunReporting
- PerRunReportingBase
- PlainAttachment
- PolyType
- PolyType
- PolyTypeApi
- PolyTypeExtractor
- PosAssigner
- PostfixSelect
- ProperTypeKind
- ProtoType
- QualTypeSymAttachment
- Quasiquote
- RawTreePrinter
- RecoverableCyclicReference
- RefTree
- RefTree
- RefTreeApi
- RefTreeExtractor
- ReferenceToBoxed
- ReferenceToBoxed
- ReferenceToBoxedApi
- ReferenceToBoxedExtractor
- RefinedType
- RefinedType
- RefinedType0
- RefinedTypeApi
- RefinedTypeExtractor
- RefinementClassSymbol
- RefinementTypeRef
- ReflectStats
- ReflectiveMirror
- ReificationSupportApi
- ReificationSupportImpl
- RepeatedType
- Return
- Return
- ReturnApi
- ReturnExtractor
- RewrappingTypeProxy
- RootSymbol
- Roots
- RootsBase
- Run
- RunContextApi
- RunParsing
- RunReporting
- RuntimeClassApi
- RuntimeMirror
- SAMFunction
- Scope
- Scope
- ScopeApi
- ScopeEntry
- Select
- Select
- SelectApi
- SelectExtractor
- SelectFromArray
- SelectFromTypeTree
- SelectFromTypeTree
- SelectFromTypeTreeApi
- SelectFromTypeTreeExtractor
- SimpleTypeProxy
- SingleType
- SingleType
- SingleTypeApi
- SingleTypeExtractor
- SingletonType
- SingletonTypeApi
- SingletonTypeTree
- SingletonTypeTree
- SingletonTypeTreeApi
- SingletonTypeTreeExtractor
- StandardImporter
- StandardLiftableInstances
- StandardTypes
- StandardUnliftableInstances
- Star
- Star
- StarApi
- StarExtractor
- StaticallyAnnotatedType
- StrictTreeCopier
- StubClassSymbol
- StubSymbol
- StubTermSymbol
- SubType
- SubTypePair
- SubpatternsAttachment
- SubstMap
- SubstSymMap
- SubstThisMap
- SubstTypeMap
- SubstWildcardMap
- Super
- Super
- SuperApi
- SuperExtractor
- SuperType
- SuperType
- SuperTypeApi
- SuperTypeExtractor
- SymLoader
- SymTree
- SymTreeApi
- Symbol
- SymbolApi
- SymbolContextApiImpl
- SymbolNames
- SymbolOps
- SymbolTableInternal
- Template
- Template
- TemplateApi
- TemplateExtractor
- TemplateMirror
- TermName
- TermName
- TermNameApi
- TermNameExtractor
- TermNames
- TermNamesApi
- TermSymbol
- TermSymbolApi
- TermTree
- TermTreeApi
- This
- This
- ThisApi
- ThisExtractor
- ThisSubstituter
- ThisType
- ThisType
- ThisTypeApi
- ThisTypeExtractor
- Throw
- Throw
- ThrowApi
- ThrowExtractor
- ThrownException
- Transformer
- Traverser
- Tree
- TreeApi
- TreeContextApiImpl
- TreeCopier
- TreeCopierOps
- TreeGen
- TreePrinter
- TreeReplacer
- TreeStackTraverser
- TreeSubstituter
- TreeSymSubstTraverser
- TreeSymSubstituter
- TreeTypeSubstituter
- Try
- Try
- TryApi
- TryExtractor
- TypTree
- TypTreeApi
- Type
- TypeApi
- TypeApiImpl
- TypeApply
- TypeApply
- TypeApplyApi
- TypeApplyExtractor
- TypeBounds
- TypeBounds
- TypeBoundsApi
- TypeBoundsExtractor
- TypeBoundsTree
- TypeBoundsTree
- TypeBoundsTreeApi
- TypeBoundsTreeExtractor
- TypeCollector
- TypeConKind
- TypeConKind
- TypeConstraint
- TypeDef
- TypeDef
- TypeDefApi
- TypeDefExtractor
- TypeError
- TypeFolder
- TypeMap
- TypeMapTreeSubstituter
- TypeName
- TypeName
- TypeNameApi
- TypeNameExtractor
- TypeNames
- TypeNamesApi
- TypeParamVarargsAttachment
- TypeRef
- TypeRef
- TypeRefApi
- TypeRefExtractor
- TypeSkolem
- TypeSymbol
- TypeSymbolApi
- TypeTag
- TypeTag
- TypeTraverser
- TypeTree
- TypeTree
- TypeTreeApi
- TypeTreeExtractor
- TypeTreeWithDeferredRefCheck
- TypeUnwrapper
- TypeVar
- TypeVar
- Typed
- Typed
- TypedApi
- TypedExtractor
- TypedLocator
- UnApply
- UnApply
- UnApplyApi
- UnApplyExtractor
- UndoLog
- UniqueConstantType
- UniqueErasedValueType
- UniqueLiteralType
- UniqueSingleType
- UniqueSuperType
- UniqueThisType
- UniqueType
- UniqueTypeBounds
- Unliftable
- UnmappableAnnotation
- UntouchableTypeVar
- UseCase
- UseInvokeSpecial
- ValDef
- ValDef
- ValDefApi
- ValDefExtractor
- ValOrDefDef
- ValOrDefDef
- ValOrDefDefApi
- ValidateException
- ValidatingPosAssigner
- ValueClassDefinitions
- VarianceValidator
- VariancedTypeMap
- WeakTypeTag
- WeakTypeTag
- WildcardType
- abstractTypesToBounds
- adaptToNewRunMap
- cleanup
- constfold
- constructors
- definitions
- delambdafy
- dropIllegalStarTypes
- dropSingletonType
- erasure
- explicitOuter
- extensionMethods
- fields
- flatten
- gen
- genBCode
- icodes
- inferKind
- lambdaLift
- mixer
- nme
- noPrint
- noSelfType
- nodePrinters
- noopTransformer
- overridingPairs
- patmat
- pendingSuperCall
- perRunCaches
- pickler
- postErasure
- refChecks
- resetPos
- scalaPrimitives
- specializeTypes
- statistics
- superAccessors
- tailCalls
- terminal
- tpnme
- traceSymbols
- treeBrowsers
- treeChecker
- treeInfo
- typeDebug
- typeDeconstruct
- typer
- uncurry
- unwrapToClass
- unwrapToStableClass
- unwrapWrapperTypes
- wildcardExtrapolation

o

scala.tools.nsc.Global

# treeBrowsers

###

#### object treeBrowsers extends TreeBrowsers

Representing ASTs as graphs

Source
  Global.scala

Linear Supertypes
TreeBrowsers, AnyRef, Any

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. treeBrowsers
2. TreeBrowsers
3. AnyRef
4. Any

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Type Members

1.  class ASTTreeModel extends TreeModel

   Tree model for abstract syntax trees

   Tree model for abstract syntax trees

   Definition Classes
     TreeBrowsers
2.  class BrowserFrame extends AnyRef

   A window that can host the Tree widget and provide methods for displaying information

   A window that can host the Tree widget and provide methods for displaying information

   Definition Classes
     TreeBrowsers
   Version

     1.0

3.  case class ProgramTree(units: List[UnitTree]) extends Global.Tree with Product with Serializable

   Pseudo tree class, so that all JTree nodes are treated uniformly

   Pseudo tree class, so that all JTree nodes are treated uniformly

   Definition Classes
     TreeBrowsers
4.  class SwingBrowser extends AnyRef

   Java Swing pretty printer for Scala abstract syntax trees.

   Java Swing pretty printer for Scala abstract syntax trees.

   Definition Classes
     TreeBrowsers
5.  class TextInfoPanel extends JTextArea

   Present detailed information about the selected tree node.

   Present detailed information about the selected tree node.

   Definition Classes
     TreeBrowsers
6.  case class UnitTree(unit: Global.CompilationUnit) extends Global.Tree with Product with Serializable

   Pseudo tree class, so that all JTree nodes are treated uniformly

   Pseudo tree class, so that all JTree nodes are treated uniformly

   Definition Classes
     TreeBrowsers

### Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##(): Int
   Definition Classes
     AnyRef → Any
3.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
4.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
5.  val borderSize: Int
   Definition Classes
     TreeBrowsers
6.  def clone(): AnyRef
   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws(classOf[java.lang.CloneNotSupportedException]) @native()
7.  def create(): SwingBrowser
   Definition Classes
     TreeBrowsers
8.  final def eq(arg0: AnyRef): Boolean
   Definition Classes
     AnyRef
9.  def equals(arg0: AnyRef): Boolean
   Definition Classes
     AnyRef → Any
10.  def finalize(): Unit
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.Throwable])
11.  final def getClass(): Class[_ <: AnyRef]
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
12.  val global: Global.this.type
    Definition Classes
      treeBrowsers → TreeBrowsers
13.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
14.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
15.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
16.  final def notify(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
17.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
18.  final def synchronized[T0](arg0: => T0): T0
    Definition Classes
      AnyRef
19.  def toString(): String
    Definition Classes
      AnyRef → Any
20.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
21.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
22.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException]) @native()
23.  object TreeInfo

    Computes different information about a tree node.

    Computes different information about a tree node. It is used as central place to do all pattern matching against Tree.

    Definition Classes
      TreeBrowsers
24.  object TypePrinter
    Definition Classes
      TreeBrowsers

### Inherited from TreeBrowsers

### Inherited from AnyRef

### Inherited from Any

### Ungrouped